package markov;


import markov.stuff.Utils;

import java.nio.ByteBuffer;
import java.util.Base64;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ShortenerByte2Impl extends ShortenerSimpleImpl {


    public ShortenerByte2Impl(Data data) {
        super(data);
    }

    String fromInts(Stream<Integer> ints) {
        List<Byte> bl = ints.flatMap(i -> {
            Stream.Builder<Byte> builder = Stream.<Byte>builder();
            if (i < 0b00111111_11111111) {
                byte[] bytes = Utils.toByteArray(i);
                builder.add((byte) (bytes[2] | 0b01000000));
                builder.add(bytes[3]);
            } else {
                for (byte b : Utils.toByteArray(i)) {
                    builder.add(b);
                }
            }
            return builder.build();
        }).collect(Collectors.toList());
        ByteBuffer bb = ByteBuffer.allocate(bl.size());
        for (Byte b : bl) {
            bb.put(b);
        }
        bb.rewind();

        return Base64.getEncoder().encodeToString(bb.array());
    }

}
