package markov;

import java.util.Base64;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class ShortenerStringImpl extends ShortenerSimpleImpl {
    public ShortenerStringImpl(Data data) {
        super(data);
    }

    String fromInts(Stream<Integer> ints) {
        String cps = ints.map(i -> new String(Character.toChars(i))).collect(Collectors.joining());
        return Base64.getEncoder().encodeToString(cps.getBytes());
    }
}
